<template>
    <div class="radio-item" v-if="value" :style="containerWidth">
        <input type="radio" class="radio" :id="id" :value="value" v-model="computedLocalChecked" @change="handleChange" :required="required"/>
        <label :for="id"><slot/></label>
    </div>
</template>

<script>
	export default {
	    name: 'Radio',
        props: {
	        checked: [String, Number],
            value: [String, Number, Object],
            width: [String, Number],
            required: Boolean
        },
        model: {
            prop: 'checked',
            event: 'input'
        },
        data(){
            return {
                localChecked: this.checked,
            }
        },
        computed:{
            computedLocalChecked: {
                get() {
                    return this.localChecked
                },
                set(val) {
                    this.localChecked = val
                }
            },
            containerWidth(){
                return {
                    'flex-basis': this.width ? this.width : '100%'
                }
            },
		    id(){
                return `radio_item_${this._uid}_${this.value}`
            }
        },
        watch: {
            checked(newVal, oldVal) {
                this.computedLocalChecked = newVal
            },
            computedLocalChecked(newVal, oldVal) {
                this.$emit('input', this.computedLocalChecked)
            }
        },
        methods: {
            handleChange({ target: { checked } }) {
                const value = this.value
                this.computedLocalChecked = value
                // Change is only emitted on user interaction
                this.$emit('change', checked ? value : null)
            }
        }
	}
</script>

<style lang="scss" scoped>
.radio-item, .pc-dop .box__pcDop--white .box__pcDop--top .box__pcDop--right .box__pcDopRight--element .radio-item{
    height: 30px;
    margin-top: 10px;
    flex-basis: 22%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    flex-wrap: wrap;

    .radio{
        position: absolute;
        z-index: -1;
        opacity: 0;
        margin: 10px 0 0 7px;
    }

    .radio + .greyColor {
        color: #b0b0b0;
        margin-left: 0;
    }

    label {
        position: relative;
        cursor: pointer;

        color: #c4c4c4;
        font-family: "Geometria Bold";
        font-size: 14px;
        font-weight: 700;
        line-height: 15px;
        transition: color .5s ease;

        &:before {
            content: '';
            position: absolute;
            top: -5px;
            right: -50px;
            width: 22px;
            height: 22px;
            border: 1px solid #CDD1DA;
            border-radius: 50%;
            background-color: #d9d9d9;
            transition: box-shadow .5s ease;
        }
        &:after {
            content: '';
            position: absolute;
            top: -5px;
            right: -49px;
            width: 23px;
            height: 23px;
            border-radius: 50%;
            background: #2b5ede;
            box-shadow: inset 0 1px 1px rgba(0, 0, 0, .5);
            opacity: 0;
            transition: opacity .5s ease;
        }
    }

    :checked{
        + label {
            color: #ffba00;

            &:after{
                opacity: 1;
            }
            &:before{
                box-shadow: 0 0 0 3px rgba(255, 255, 0, .7);
            }
        }
    }
}
</style>
